<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getProductsResponse StructType
 * @subpackage Structs
 */
class GetProductsResponse extends AbstractStructBase
{
    /**
     * The getProductsResult
     * Meta informations extracted from the WSDL
     * - arrayType: tns:Product[]
     * - ref: soap-enc:arrayType
     * @var \StructType\Product[]
     */
    public $getProductsResult;
    /**
     * Constructor method for getProductsResponse
     * @uses GetProductsResponse::setGetProductsResult()
     * @param \StructType\Product[] $getProductsResult
     */
    public function __construct(array $getProductsResult = array())
    {
        $this
            ->setGetProductsResult($getProductsResult);
    }
    /**
     * Get getProductsResult value
     * @return \StructType\Product[]|null
     */
    public function getGetProductsResult()
    {
        return $this->getProductsResult;
    }
    /**
     * Set getProductsResult value
     * @throws \InvalidArgumentException
     * @param \StructType\Product[] $getProductsResult
     * @return \StructType\GetProductsResponse
     */
    public function setGetProductsResult(array $getProductsResult = array())
    {
        foreach ($getProductsResult as $getProductsResponseGetProductsResultItem) {
            // validation for constraint: itemType
            if (!$getProductsResponseGetProductsResultItem instanceof \StructType\Product) {
                throw new \InvalidArgumentException(sprintf('The getProductsResult property can only contain items of \StructType\Product, "%s" given', is_object($getProductsResponseGetProductsResultItem) ? get_class($getProductsResponseGetProductsResultItem) : gettype($getProductsResponseGetProductsResultItem)), __LINE__);
            }
        }
        $this->getProductsResult = $getProductsResult;
        return $this;
    }
    /**
     * Add item to getProductsResult value
     * @throws \InvalidArgumentException
     * @param \StructType\Product $item
     * @return \StructType\GetProductsResponse
     */
    public function addToGetProductsResult(\StructType\Product $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Product) {
            throw new \InvalidArgumentException(sprintf('The getProductsResult property can only contain items of \StructType\Product, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->getProductsResult[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetProductsResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
